<!DOCTYPE html lang="fr">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="UTF-8">
    <style type="text/css">
        body {
            padding: 10px;
        }
        input[type="color"],
        input[type="date"],
        input[type="datetime"],
        input[type="datetime-local"],
        input[type="email"],
        input[type="month"],
        input[type="number"],
        input[type="password"],
        input[type="search"],
        input[type="tel"],
        input[type="text"],
        input[type="time"],
        input[type="url"],
        input[type="week"],
        select:focus,
        textarea {
          font-size: 17px;
        }
        .v-counter {
            border-radius: 5px;
            overflow: auto;
            padding: 0px 4px;
            border: 1px solid #323140;
            margin: 10px 0;
        }
        h1 {
            text-align: center;
        }
        input[type=button]:hover {
            color: black;
            font-weight: bold;
            background-color: transparent;
        }
        .v-counter span {
            font-size: 17px;
            color: black;
            font-family: 'Open Sans';
        }
        .moreButtons {
            margin: 10px 0;
            border: 1px solid black;
            border-radius: 5px;
            text-align: center;
        }
        .nameCounter {
            text-align: right !important;
            width: calc(100% - 180px);
        }
        .addCounter, .saveCounters, .sendCounters {
            font-size: 25px;
        }
        #resultSave {
            width: 100%;
            height: 50px;
            text-align: center;
            color: green;
            font-weight: bold;
        }
        .minusBtn, .plusBtn {
            width: 60px;
        }
        .count {
            width: 50px;
        }
        input[type=button], input[type=text] {
            display: inline-block;
            background-color: transparent;
            outline: none;
            border: none;
            text-align: center;
            cursor: pointer;
            padding: 0px;
            color: black;
            height: 60px;
            font-family: 'Open Sans';
        }
    </style>
</head>
<body onload="getBackCookie()">
    <h1>Compteurs d'avis</h1>
    <div class="v-counter" data-number=0>
        <input class="nameCounter" type="text" placeholder="Titre" name="counter1label" /><input type="button" class="minusBtn" value="-" /><input type="text" size="25" value="0" class="count" name="counter1value" /><input type="button" class="plusBtn" value="+" />
    </div>
    <div id="resultSave"></div>
    <div class="moreButtons">
        <input type="button" class="addCounter" value="Ajouter compteur" />
    </div>
    <div class="moreButtons">
        <input type="button" class="saveCounters" value="Sauvegarder" />
    </div>
    <div class="moreButtons">
        <input type="button" class="sendCounters" value="Envoyer les résultats" />
    </div>
    <script type="text/javascript">
        // Store references that all functions can use.
        var resultEl = document.querySelector(".resultSet"),
          plusMinusWidgets = document.querySelectorAll(".v-counter");

        // Attach the handlers to each plus-minus thing
        for (var i = 0; i < plusMinusWidgets.length; i++) {
          plusMinusWidgets[i].querySelector(".minusBtn").addEventListener("click", clickHandler);
          plusMinusWidgets[i].querySelector(".plusBtn").addEventListener("click", clickHandler);
          plusMinusWidgets[i].querySelector(".count").addEventListener("change", changeHandler);
        }
        
        document.querySelector(".addCounter").addEventListener("click", addCounterHandler);
        document.querySelector(".saveCounters").addEventListener("click", saveCountersHandler);
        document.querySelector(".sendCounters").addEventListener("click", sendCountersHandler);

        /*****
         * both plus and minus use the same function, but value is set by the class of the
         *  button
         *****/
        function clickHandler(event) {
          // reference to the count input field
          var countEl = event.target.parentNode.querySelector(".count");
          if (event.target.className.match(/\bminusBtn\b/)) {
            countEl.value = Number(countEl.value) - 1;
          } else if (event.target.className.match(/\bplusBtn\b/)) {
            countEl.value = Number(countEl.value) + 1;

          }
          // When we programmatically change the value, we need to manually trigger
          //  the change event.
          triggerEvent(countEl, "change");
        };
        
        function addCounterHandler(event) {
            var lastCounterAll = document.querySelectorAll(".v-counter");
            var lastCounter = lastCounterAll[lastCounterAll.length-1];
            var lastCounterNumber = lastCounter.getAttribute("data-number");
            lastCounterNumber++;
            var elementToBeAdded = '<div class="v-counter" data-number=';
            elementToBeAdded += lastCounterNumber;
            elementToBeAdded += '><input class="nameCounter" type="text" placeholder="Titre" name="counter';
            elementToBeAdded += lastCounterNumber;
            elementToBeAdded += 'label" /><input type="button" class="minusBtn" value="-" /><input type="text" size="25" value="0" class="count" name="counter';
            elementToBeAdded += lastCounterNumber;
            elementToBeAdded += 'value" /><input type="button" class="plusBtn" value="+" /></div>';
            lastCounter.insertAdjacentHTML("afterend", elementToBeAdded);
            document.querySelectorAll(".v-counter")[lastCounterNumber].querySelector(".minusBtn").addEventListener("click", clickHandler);
            document.querySelectorAll(".v-counter")[lastCounterNumber].querySelector(".plusBtn").addEventListener("click", clickHandler);
            document.querySelectorAll(".v-counter")[lastCounterNumber].querySelector(".count").addEventListener("change", changeHandler);
        };
        
        function saveCountersHandler(event) {
            var lastCounterAll = document.querySelectorAll(".v-counter");
            var counters = "";
            for (let i=0; i<lastCounterAll.length; i++) {
                counters += lastCounterAll[i].querySelector(".nameCounter").value;
                counters += "|";
                counters += lastCounterAll[i].querySelector(".count").value;
                if (i != lastCounterAll.length-1) {
                    counters += "#";
                }
            }
            setCookie("counters", counters, 3);
        };
        
        function sendCountersHandler(event) {
            var lastCounterAll = document.querySelectorAll(".v-counter");
            var counters = "";
            for (let i=0; i<lastCounterAll.length; i++) {
                counters += lastCounterAll[i].querySelector(".nameCounter").value;
                counters += "|";
                counters += lastCounterAll[i].querySelector(".count").value;
                if (i != lastCounterAll.length-1) {
                    counters += "#";
                }
            }
            const xhttp = new XMLHttpRequest();
            xhttp.onload = function() {
                if (this.responseText == "OK") {
                    document.getElementById("resultSave").innerHTML = "C'est tout bon !";
                    deleteCookie();
                } else {
                    document.getElementById("resultSave").innerHTML = this.responseText;
                }
            }
            xhttp.open("POST", "saveData.php");
            xhttp.send(counters);
        };

        /*****
         * changeHandler() processes whenever a plusMinusWidget's count el is changed.
         *  It iterates over all plusMinusWidgets, gets their count, and outputs that
         *  to the given resultEl input field.
         *****/
        function changeHandler(event) {
          // remove all value from the result el.
          resultEl.value = 0;
          /******
           * Here is the only functional change, per your comment. Rather
           *  concatenating a string, you want to sum values of the 
           *  plusMinusWidget. To do this, we need to cast the value of each
           *  plusMinusWidget to a Number value, and add that to the Number
           *  value of the resultEl.
           *****/
          for (var i = 0; i < plusMinusWidgets.length; i++) {
            // Add the current plusMinusWidget value to the resultEl value.
            resultEl.value = Number(resultEl.value) + Number(plusMinusWidgets[i].querySelector('.count').value);

          }
        };
        
        function setCookie(cname, cvalue, exdays) {
            const d = new Date();
            d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
            let expires = "expires="+d.toUTCString();
            document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
        }

        function getCookie(cname) {
            let name = cname + "=";
            let ca = document.cookie.split(';');
            for(let i = 0; i < ca.length; i++) {
                let c = ca[i];
                while (c.charAt(0) == ' ') {
                    c = c.substring(1);
                }
                if (c.indexOf(name) == 0) {
                    return c.substring(name.length, c.length);
                }
            }
            return "";
        }

        function getBackCookie() {
            let counters = getCookie("counters");
            if (counters != "") {
                let countersArray = counters.split("#");
                for (let i=0; i<countersArray.length; i++) {
                    let counterInfo = countersArray[i].split("|");
                    if (!document.querySelectorAll(".v-counter")[i]) {
                        triggerEvent(document.querySelector(".addCounter"), "click");
                    }
                    document.querySelectorAll(".v-counter")[i].querySelector(".nameCounter").value =counterInfo[0];
                    document.querySelectorAll(".v-counter")[i].querySelector(".count").value = counterInfo[1];
                }
            }
        }
        
        function deleteCookie() {
            document.cookie = "counters=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;";
        }
        
        
        /*****
         * triggerEvent() -- function to trigger an HTMLEvent on a given element.
         *  similar to jquery's trigger(), simply a convenience function. Not the
         *  point of this exercise.
         *****/

        function triggerEvent(el, type){
           if ('createEvent' in document) {
                // modern browsers, IE9+
                var e = document.createEvent('HTMLEvents');
                e.initEvent(type, false, true);
                el.dispatchEvent(e);
            } else {
                // IE 8
                var e = document.createEventObject();
                e.eventType = type;
                el.fireEvent('on'+e.eventType, e);
            }
        }
    </script>
</body>
</html>